package com.objectriver.runtime.webrpc.server;

import com.objectriver.runtime.util.StringUtility;

import java.util.HashMap;
/**
 * ServerType enumeration class.
 * <p>
 * Generated from model/module ServerType and Enum.java.tmpl.
 * This file should not be modified.
 */
    public final class ServerType {
        public static final String typeName = "ServerType";
        private static final String[] _menu = {"tyrus","glassfish","tomcat","jboss","weblogic","websphere","jetty"};

		/** Use this method to get a valid list of descriptions for this enumeration.
			@return String[] of valid values that may be used with valueOfDescription() factory.
		*/
        public static final int tyrusInt = 0;
        public static final ServerType tyrus = new ServerType(_menu[0],tyrusInt,_menu[0]);
        public static final int glassfishInt = 1;
        public static final ServerType glassfish = new ServerType(_menu[1],glassfishInt,_menu[1]);
        public static final int tomcatInt = 2;
        public static final ServerType tomcat = new ServerType(_menu[2],tomcatInt,_menu[2]);
        public static final int jbossInt = 3;
        public static final ServerType jboss = new ServerType(_menu[3],jbossInt,_menu[3]);
        public static final int weblogicInt = 4;
        public static final ServerType weblogic = new ServerType(_menu[4],weblogicInt,_menu[4]);
        public static final int websphereInt = 5;
        public static final ServerType websphere = new ServerType(_menu[5],websphereInt,_menu[5]);
        public static final int jettyInt = 6;
        public static final ServerType jetty = new ServerType(_menu[6],jettyInt,_menu[6]);

        private static final HashMap hashMap;
        static {
            hashMap = new HashMap(_menu.length);
            hashMap.put(_menu[0],tyrus);
            hashMap.put(_menu[1],glassfish);
            hashMap.put(_menu[2],tomcat);
            hashMap.put(_menu[3],jboss);
            hashMap.put(_menu[4],weblogic);
            hashMap.put(_menu[5],websphere);
            hashMap.put(_menu[6],jetty);
        }

		/** Private constructor. Must use valueOf() or instanceOf() factories.
		*/
        private String name = null;
        private int number;
        private ServerType(String name, int number, String description) {
            this.name = name;
            this.number = number;
        }
        public int intValue() {
            return number;
        }

        public static ServerType valueOf(String string) {
            Object enumobject = hashMap.get(string);
            return (ServerType)enumobject;
        }
        public static ServerType valueOf(int enumvalue) {
            switch(enumvalue) {
                case tyrusInt: return tyrus;
                case glassfishInt: return glassfish;
                case tomcatInt: return tomcat;
                case jbossInt: return jboss;
                case weblogicInt: return weblogic;
                case websphereInt: return websphere;
                case jettyInt: return jetty;
                default:
                    return null;
            }
        }

		/** equals simply compares addresses because of immutability.
		* @return boolean
		*/
        public boolean equals(Object o) {
            return (this==o);
        }
		/** calculate hashCode
		* @return hashCode
		*/
        public int hashCode() {
            return this.toString().hashCode();
        }
		/** Get type name string for use with dynamic type factorys
		* @return typeName string
		*/
        public String getTypeName() {
            return typeName;
        }
		/** protected method for visiting types.
		* @param visitor object that visits types.
		* @param decend boolean indicating decent.
		*/

    }
